<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>celGameClientManager Class Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">celGameClientManager Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="celGameClientManager" -->
<p>This is an interface you should implement in order to manage the events from the client.  
 <a href="classcelGameClientManager.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="network_8h_source.html">physicallayer/network.h</a>&gt;</code></p>

<p><a href="classcelGameClientManager-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classcelGameClientManager.html#abd024e8b9617a69d068aacd9c343f8e6">ClientEnd</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The client will be closed.  <a href="#abd024e8b9617a69d068aacd9c343f8e6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structiCelEntity.html">iCelEntity</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classcelGameClientManager.html#a5ebea8bf343b566d6817aabf566bf621">CreateNetworkLinkTarget</a> (celNetworkLinkType link_type, <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> creation_time, <a class="el" href="structiCelPersistentDataList.html">iCelPersistentDataList</a> *creation_data, bool player_controlled)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">A network link has been set up on the server side between a server entity and this client.  <a href="#a5ebea8bf343b566d6817aabf566bf621"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classcelGameClientManager.html#a968634071bd19f2e641947140b4ce3c8">HandleServerEvent</a> (celServerEventType event_type, <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> event_time, <a class="el" href="structiCelDataBuffer.html">iCelDataBuffer</a> *event_data)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">A server event has been catched.  <a href="#a968634071bd19f2e641947140b4ce3c8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classcelGameClientManager.html#a237ee6c3a3904eafd3d021f06558ee4b">LevelChanged</a> (<a class="el" href="classcelGameInfo.html">celGameInfo</a> *new_game)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The level has changed.  <a href="#a237ee6c3a3904eafd3d021f06558ee4b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classcelGameClientManager.html#a1a42f602531b4a95ff887f11058ea677">NetworkLinkControlChanged</a> (<a class="el" href="structiCelEntity.html">iCelEntity</a> *entity, bool player_controlled)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">There is a change in the way the entity is controlled, ie if it is controlled by the client or by the server side.  <a href="#a1a42f602531b4a95ff887f11058ea677"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classcelGameClientManager.html#aa5b2a07488d63ffc26c7c401381a3ea6">NetworkLinkRemoved</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> deletion_time, <a class="el" href="structiCelEntity.html">iCelEntity</a> *entity)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The network link to the specified entity is closing.  <a href="#aa5b2a07488d63ffc26c7c401381a3ea6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classcelGameClientManager.html#a8527af0860e7ecdef1053f7db9d4dd32">PlayerValidated</a> (<a class="el" href="classcelPlayer.html">celPlayer</a> *player)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The data of the player has been validated by the server.  <a href="#a8527af0860e7ecdef1053f7db9d4dd32"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This is an interface you should implement in order to manage the events from the client. </p>
<p>You can use it to:</p>
<ul>
<li>listen for changes in the state of the network connection to the server.</li>
<li>get the data of the player validated by the server.</li>
<li>catch the server events.</li>
<li>handle the creation and removing of the network links.</li>
<li>close the client. </li>
</ul>

<p>Definition at line <a class="el" href="network_8h_source.html#l00657">657</a> of file <a class="el" href="network_8h_source.html">network.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="abd024e8b9617a69d068aacd9c343f8e6"></a><!-- doxytag: member="celGameClientManager::ClientEnd" ref="abd024e8b9617a69d068aacd9c343f8e6" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classcelGameClientManager.html#abd024e8b9617a69d068aacd9c343f8e6">celGameClientManager::ClientEnd</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The client will be closed. </p>
<p>You should delete here the physical layer of the client. </p>

</div>
</div>
<a class="anchor" id="a5ebea8bf343b566d6817aabf566bf621"></a><!-- doxytag: member="celGameClientManager::CreateNetworkLinkTarget" ref="a5ebea8bf343b566d6817aabf566bf621" args="(celNetworkLinkType link_type, csTicks creation_time, iCelPersistentDataList *creation_data, bool player_controlled)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structiCelEntity.html">iCelEntity</a>* <a class="el" href="classcelGameClientManager.html#a5ebea8bf343b566d6817aabf566bf621">celGameClientManager::CreateNetworkLinkTarget</a> </td>
          <td>(</td>
          <td class="paramtype">celNetworkLinkType&#160;</td>
          <td class="paramname"><em>link_type</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a>&#160;</td>
          <td class="paramname"><em>creation_time</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structiCelPersistentDataList.html">iCelPersistentDataList</a> *&#160;</td>
          <td class="paramname"><em>creation_data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>player_controlled</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>A network link has been set up on the server side between a server entity and this client. </p>
<p>A copy entity must be created on this client side. This copy entity will be the adressee of the updates from the network link. </p>
<p>If the server is available in the same process, you can simply use the entity of the server and then return 0 to this function. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">link_type</td><td>the type of the network link. You should use it to know what type of entity has to be created. </td></tr>
    <tr><td class="paramname">creation_time</td><td>the time at which the network link is created. </td></tr>
    <tr><td class="paramname">creation_data</td><td>the persistent data of the entity at the creation of the network link. </td></tr>
    <tr><td class="paramname">player_controlled</td><td>true if the entity is controlled on the client side, false it is controlled on the server side. </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>the copy entity. </dd></dl>

</div>
</div>
<a class="anchor" id="a968634071bd19f2e641947140b4ce3c8"></a><!-- doxytag: member="celGameClientManager::HandleServerEvent" ref="a968634071bd19f2e641947140b4ce3c8" args="(celServerEventType event_type, csTicks event_time, iCelDataBuffer *event_data)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classcelGameClientManager.html#a968634071bd19f2e641947140b4ce3c8">celGameClientManager::HandleServerEvent</a> </td>
          <td>(</td>
          <td class="paramtype">celServerEventType&#160;</td>
          <td class="paramname"><em>event_type</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a>&#160;</td>
          <td class="paramname"><em>event_time</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structiCelDataBuffer.html">iCelDataBuffer</a> *&#160;</td>
          <td class="paramname"><em>event_data</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>A server event has been catched. </p>

</div>
</div>
<a class="anchor" id="a237ee6c3a3904eafd3d021f06558ee4b"></a><!-- doxytag: member="celGameClientManager::LevelChanged" ref="a237ee6c3a3904eafd3d021f06558ee4b" args="(celGameInfo *new_game)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classcelGameClientManager.html#a237ee6c3a3904eafd3d021f06558ee4b">celGameClientManager::LevelChanged</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classcelGameInfo.html">celGameInfo</a> *&#160;</td>
          <td class="paramname"><em>new_game</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The level has changed. </p>
<p>The client need to do <a class="el" href="structiCelGameClient.html#abbd38fbb4892af3680c5a78ed67204c3" title="Indicate that the client has loaded everything and is ready to play.">iCelGameClient::SetReady</a> when the new level is loaded. </p>

</div>
</div>
<a class="anchor" id="a1a42f602531b4a95ff887f11058ea677"></a><!-- doxytag: member="celGameClientManager::NetworkLinkControlChanged" ref="a1a42f602531b4a95ff887f11058ea677" args="(iCelEntity *entity, bool player_controlled)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classcelGameClientManager.html#a1a42f602531b4a95ff887f11058ea677">celGameClientManager::NetworkLinkControlChanged</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiCelEntity.html">iCelEntity</a> *&#160;</td>
          <td class="paramname"><em>entity</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>player_controlled</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>There is a change in the way the entity is controlled, ie if it is controlled by the client or by the server side. </p>
<p>If the entity is now controlled on the client side, you should then set a behavior to it. Most presumably, the behavior will catch the actions of the player and update accordingly the entity. </p>
<p>If the entity is now controlled on the server side, you should then remove any behavior from the entity and let the client update it from the server. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">entity</td><td>the entity which is networked linked. </td></tr>
    <tr><td class="paramname">player_controlled</td><td>true if the entity is controlled by the client side, false if it is controlled by the server side. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aa5b2a07488d63ffc26c7c401381a3ea6"></a><!-- doxytag: member="celGameClientManager::NetworkLinkRemoved" ref="aa5b2a07488d63ffc26c7c401381a3ea6" args="(csTicks deletion_time, iCelEntity *entity)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classcelGameClientManager.html#aa5b2a07488d63ffc26c7c401381a3ea6">celGameClientManager::NetworkLinkRemoved</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a>&#160;</td>
          <td class="paramname"><em>deletion_time</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structiCelEntity.html">iCelEntity</a> *&#160;</td>
          <td class="paramname"><em>entity</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The network link to the specified entity is closing. </p>
<p>The client can remove the entity from the physical layer. </p>

</div>
</div>
<a class="anchor" id="a8527af0860e7ecdef1053f7db9d4dd32"></a><!-- doxytag: member="celGameClientManager::PlayerValidated" ref="a8527af0860e7ecdef1053f7db9d4dd32" args="(celPlayer *player)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classcelGameClientManager.html#a8527af0860e7ecdef1053f7db9d4dd32">celGameClientManager::PlayerValidated</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classcelPlayer.html">celPlayer</a> *&#160;</td>
          <td class="paramname"><em>player</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The data of the player has been validated by the server. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>physicallayer/<a class="el" href="network_8h_source.html">network.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
